Index: CKEditor/trunk/_source/plugins/toolbar/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/toolbar/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/toolbar/plugin.js	(revision 6904)
@@ -37,4 +37,5 @@
 		{
 			modes : { wysiwyg : 1, source : 1 },
+			readOnly : 1,
 
 			exec : function( editor )
@@ -59,82 +60,93 @@
 		init : function( editor )
 		{
+			var endFlag;
+
 			var itemKeystroke = function( item, keystroke )
 			{
-				var next, nextToolGroup, groupItemsCount;
-				var rtl = editor.lang.dir == 'rtl';
+				var next, toolbar;
+				var rtl = editor.lang.dir == 'rtl',
+					toolbarGroupCycling = editor.config.toolbarGroupCycling;
+
+				toolbarGroupCycling = toolbarGroupCycling === undefined || toolbarGroupCycling;
 
 				switch ( keystroke )
 				{
-					case rtl ? 37 : 39 :					// RIGHT-ARROW
 					case 9 :					// TAB
+					case CKEDITOR.SHIFT + 9 :	// SHIFT + TAB
+						// Cycle through the toolbars, starting from the one
+						// closest to the current item.
+						while ( !toolbar || !toolbar.items.length )
+						{
+							toolbar = keystroke == 9 ?
+								( ( toolbar ? toolbar.next : item.toolbar.next ) || editor.toolbox.toolbars[ 0 ] ) :
+								( ( toolbar ? toolbar.previous : item.toolbar.previous ) || editor.toolbox.toolbars[ editor.toolbox.toolbars.length - 1 ] );
+
+							// Look for the first item that accepts focus.
+							if ( toolbar.items.length )
+							{
+								item = toolbar.items[ endFlag ? ( toolbar.items.length - 1 ) : 0 ];
+								while ( item && !item.focus )
+								{
+									item = endFlag ? item.previous : item.next;
+
+									if ( !item )
+										toolbar = 0;
+								}
+							}
+						}
+
+						if ( item )
+							item.focus();
+
+						return false;
+
+					case rtl ? 37 : 39 :		// RIGHT-ARROW
+					case 40 :					// DOWN-ARROW
+						next = item;
 						do
 						{
 							// Look for the next item in the toolbar.
-							next = item.next;
-
-							if ( !next )
-							{
-								nextToolGroup = item.toolbar.next;
-								groupItemsCount = nextToolGroup && nextToolGroup.items.length;
-
-								// Bypass the empty toolgroups.
-								while ( groupItemsCount === 0 )
-								{
-									nextToolGroup = nextToolGroup.next;
-									groupItemsCount = nextToolGroup && nextToolGroup.items.length;
-								}
-
-								if ( nextToolGroup )
-									next = nextToolGroup.items[ 0 ];
-							}
-
-							item = next;
-						}
-						while ( item && !item.focus )
+							next = next.next;
+
+							// If it's the last item, cycle to the first one.
+							if ( !next && toolbarGroupCycling )
+								next = item.toolbar.items[ 0 ];
+						}
+						while ( next && !next.focus )
 
 						// If available, just focus it, otherwise focus the
 						// first one.
-						if ( item )
-							item.focus();
+						if ( next )
+							next.focus();
 						else
-							editor.toolbox.focus();
+							// Send a TAB.
+							itemKeystroke( item, 9 );
 
 						return false;
 
-					case rtl ? 39 : 37 :					// LEFT-ARROW
-					case CKEDITOR.SHIFT + 9 :	// SHIFT + TAB
+					case rtl ? 39 : 37 :		// LEFT-ARROW
+					case 38 :					// UP-ARROW
+						next = item;
 						do
 						{
 							// Look for the previous item in the toolbar.
-							next = item.previous;
-
-							if ( !next )
-							{
-								nextToolGroup = item.toolbar.previous;
-								groupItemsCount = nextToolGroup && nextToolGroup.items.length;
-
-								// Bypass the empty toolgroups.
-								while ( groupItemsCount === 0 )
-								{
-									nextToolGroup = nextToolGroup.previous;
-									groupItemsCount = nextToolGroup && nextToolGroup.items.length;
-								}
-
-								if ( nextToolGroup )
-									next = nextToolGroup.items[ groupItemsCount - 1 ];
-							}
-
-							item = next;
-						}
-						while ( item && !item.focus )
+							next = next.previous;
+
+							// If it's the first item, cycle to the last one.
+							if ( !next && toolbarGroupCycling )
+								next = item.toolbar.items[ item.toolbar.items.length - 1 ];
+						}
+						while ( next && !next.focus )
 
 						// If available, just focus it, otherwise focus the
 						// last one.
-						if ( item )
-							item.focus();
+						if ( next )
+							next.focus();
 						else
 						{
-							var lastToolbarItems = editor.toolbox.toolbars[ editor.toolbox.toolbars.length - 1 ].items;
-							lastToolbarItems[ lastToolbarItems.length - 1 ].focus();
+							endFlag = 1;
+							// Send a SHIFT + TAB.
+							itemKeystroke( item, CKEDITOR.SHIFT + 9 );
+							endFlag = 0;
 						}
 
@@ -161,5 +173,5 @@
 						var labelId = CKEDITOR.tools.getNextId();
 
-						var output = [ '<div class="cke_toolbox" role="toolbar" aria-labelledby="', labelId, '" onmousedown="return false;"' ],
+						var output = [ '<div class="cke_toolbox" role="group" aria-labelledby="', labelId, '" onmousedown="return false;"' ],
 							expanded =  editor.config.toolbarStartupExpanded !== false,
 							groupStarted;
@@ -168,5 +180,5 @@
 
 						// Sends the ARIA label.
-						output.push( '<span id="', labelId, '" class="cke_voice_label">', editor.lang.toolbar, '</span>' );
+						output.push( '<span id="', labelId, '" class="cke_voice_label">', editor.lang.toolbars, '</span>' );
 
 						var toolbars = editor.toolbox.toolbars,
@@ -179,5 +191,9 @@
 						for ( var r = 0 ; r < toolbar.length ; r++ )
 						{
-							var row = toolbar[ r ];
+							var toolbarId,
+								toolbarObj = 0,
+								toolbarName,
+								row = toolbar[ r ],
+								items;
 
 							// It's better to check if the row object is really
@@ -189,7 +205,4 @@
 								continue;
 
-							var toolbarId = CKEDITOR.tools.getNextId(),
-								toolbarObj = { id : toolbarId, items : [] };
-
 							if ( groupStarted )
 							{
@@ -204,31 +217,50 @@
 							}
 
-							output.push( '<span id="', toolbarId, '" class="cke_toolbar" role="presentation"><span class="cke_toolbar_start"></span>' );
-
-							// Add the toolbar to the "editor.toolbox.toolbars"
-							// array.
-							var index = toolbars.push( toolbarObj ) - 1;
-
-							// Create the next/previous reference.
-							if ( index > 0 )
-							{
-								toolbarObj.previous = toolbars[ index - 1 ];
-								toolbarObj.previous.next = toolbarObj;
-							}
+							items = row.items || row;
 
 							// Create all items defined for this toolbar.
-							for ( var i = 0 ; i < row.length ; i++ )
+							for ( var i = 0 ; i < items.length ; i++ )
 							{
 								var item,
-									itemName = row[ i ];
-
-								if ( itemName == '-' )
-									item = CKEDITOR.ui.separator;
-								else
-									item = editor.ui.create( itemName );
+									itemName = items[ i ],
+									canGroup;
+
+								item = editor.ui.create( itemName );
 
 								if ( item )
 								{
-									if ( item.canGroup )
+									canGroup = item.canGroup !== false;
+
+									// Initialize the toolbar first, if needed.
+									if ( !toolbarObj )
+									{
+										// Create the basic toolbar object.
+										toolbarId = CKEDITOR.tools.getNextId();
+										toolbarObj = { id : toolbarId, items : [] };
+										toolbarName = row.name && ( editor.lang.toolbarGroups[ row.name ] || row.name );
+
+										// Output the toolbar opener.
+										output.push( '<span id="', toolbarId, '" class="cke_toolbar"',
+											( toolbarName ? ' aria-labelledby="'+ toolbarId +  '_label"' : '' ),
+											' role="toolbar">' );
+
+										// If a toolbar name is available, send the voice label.
+										toolbarName && output.push( '<span id="', toolbarId, '_label" class="cke_voice_label">', toolbarName, '</span>' );
+
+										output.push( '<span class="cke_toolbar_start"></span>' );
+
+										// Add the toolbar to the "editor.toolbox.toolbars"
+										// array.
+										var index = toolbars.push( toolbarObj ) - 1;
+
+										// Create the next/previous reference.
+										if ( index > 0 )
+										{
+											toolbarObj.previous = toolbars[ index - 1 ];
+											toolbarObj.previous.next = toolbarObj;
+										}
+									}
+
+									if ( canGroup )
 									{
 										if ( !groupStarted )
@@ -274,5 +306,6 @@
 							}
 
-							output.push( '<span class="cke_toolbar_end"></span></span>' );
+							if ( toolbarObj )
+								output.push( '<span class="cke_toolbar_end"></span></span>' );
 						}
 
@@ -295,4 +328,5 @@
 							editor.addCommand( 'toolbarCollapse',
 								{
+									readOnly : 1,
 									exec : function( editor )
 									{
@@ -360,6 +394,4 @@
 						if ( instance.clickFn ) CKEDITOR.tools.removeFunction( instance.clickFn );
 						if ( instance.keyDownFn ) CKEDITOR.tools.removeFunction( instance.keyDownFn );
-
-						if ( instance.index ) CKEDITOR.ui.button._.instances[ instance.index ] = null;
 					}
 				}
@@ -367,21 +399,24 @@
 
 			editor.addCommand( 'toolbarFocus', commands.toolbarFocus );
+
+			editor.ui.add( '-', CKEDITOR.UI_SEPARATOR, {} );
+			editor.ui.addHandler( CKEDITOR.UI_SEPARATOR,
+			{
+				create: function()
+				{
+					return {
+						render : function( editor, output )
+						{
+							output.push( '<span class="cke_separator" role="separator"></span>' );
+							return {};
+						}
+					};
+				}
+			});
 		}
 	});
 })();
 
-/**
- * The UI element that renders a toolbar separator.
- * @type Object
- * @example
- */
-CKEDITOR.ui.separator =
-{
-	render : function( editor, output )
-	{
-		output.push( '<span class="cke_separator" role="separator"></span>' );
-		return {};
-	}
-};
+CKEDITOR.UI_SEPARATOR = 'separator';
 
 /**
@@ -428,38 +463,34 @@
  * config.toolbar_Full =
  * [
- *     ['Source','-','Save','NewPage','Preview','-','Templates'],
- *     ['Cut','Copy','Paste','PasteText','PasteFromWord','-','Print', 'SpellChecker', 'Scayt'],
- *     ['Undo','Redo','-','Find','Replace','-','SelectAll','RemoveFormat'],
- *     ['Form', 'Checkbox', 'Radio', 'TextField', 'Textarea', 'Select', 'Button', 'ImageButton', 'HiddenField'],
+ *     { name: 'document',    items : [ 'Source','-','Save','NewPage','DocProps','Preview','Print','-','Templates' ] },
+ *     { name: 'clipboard',   items : [ 'Cut','Copy','Paste','PasteText','PasteFromWord','-','Undo','Redo' ] },
+ *     { name: 'editing',     items : [ 'Find','Replace','-','SelectAll','-','SpellChecker', 'Scayt' ] },
+ *     { name: 'forms',       items : [ 'Form', 'Checkbox', 'Radio', 'TextField', 'Textarea', 'Select', 'Button', 'ImageButton', 'HiddenField' ] },
  *     '/',
- *     ['Bold','Italic','Underline','Strike','-','Subscript','Superscript'],
- *     ['NumberedList','BulletedList','-','Outdent','Indent','Blockquote','CreateDiv'],
- *     ['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'],
- *     ['BidiLtr', 'BidiRtl' ],
- *     ['Link','Unlink','Anchor'],
- *     ['Image','Flash','Table','HorizontalRule','Smiley','SpecialChar','PageBreak','Iframe'],
+ *     { name: 'basicstyles', items : [ 'Bold','Italic','Underline','Strike','Subscript','Superscript','-','RemoveFormat' ] },
+ *     { name: 'paragraph',   items : [ 'NumberedList','BulletedList','-','Outdent','Indent','-','Blockquote','CreateDiv','-','JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock','-','BidiLtr','BidiRtl' ] },
+ *     { name: 'links',       items : [ 'Link','Unlink','Anchor' ] },
+ *     { name: 'insert',      items : [ 'Image','Flash','Table','HorizontalRule','Smiley','SpecialChar','PageBreak' ] },
  *     '/',
- *     ['Styles','Format','Font','FontSize'],
- *     ['TextColor','BGColor'],
- *     ['Maximize', 'ShowBlocks','-','About']
+ *     { name: 'styles',      items : [ 'Styles','Format','Font','FontSize' ] },
+ *     { name: 'colors',      items : [ 'TextColor','BGColor' ] },
+ *     { name: 'tools',       items : [ 'Maximize', 'ShowBlocks','-','About' ] }
  * ];
  */
 CKEDITOR.config.toolbar_Full =
 [
-	['Source','-','Save','NewPage','Preview','-','Templates'],
-	['Cut','Copy','Paste','PasteText','PasteFromWord','-','Print', 'SpellChecker', 'Scayt'],
-	['Undo','Redo','-','Find','Replace','-','SelectAll','RemoveFormat'],
-	['Form', 'Checkbox', 'Radio', 'TextField', 'Textarea', 'Select', 'Button', 'ImageButton', 'HiddenField'],
+	{ name: 'document',		items : [ 'Source','-','Save','NewPage','DocProps','Preview','Print','-','Templates' ] },
+	{ name: 'clipboard',	items : [ 'Cut','Copy','Paste','PasteText','PasteFromWord','-','Undo','Redo' ] },
+	{ name: 'editing',		items : [ 'Find','Replace','-','SelectAll','-','SpellChecker', 'Scayt' ] },
+	{ name: 'forms',		items : [ 'Form', 'Checkbox', 'Radio', 'TextField', 'Textarea', 'Select', 'Button', 'ImageButton', 'HiddenField' ] },
 	'/',
-	['Bold','Italic','Underline','Strike','-','Subscript','Superscript'],
-	['NumberedList','BulletedList','-','Outdent','Indent','Blockquote','CreateDiv'],
-	['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'],
-	['BidiLtr', 'BidiRtl' ],
-	['Link','Unlink','Anchor'],
-	['Image','Flash','Table','HorizontalRule','Smiley','SpecialChar','PageBreak','Iframe'],
+	{ name: 'basicstyles',	items : [ 'Bold','Italic','Underline','Strike','Subscript','Superscript','-','RemoveFormat' ] },
+	{ name: 'paragraph',	items : [ 'NumberedList','BulletedList','-','Outdent','Indent','-','Blockquote','CreateDiv','-','JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock','-','BidiLtr','BidiRtl' ] },
+	{ name: 'links',		items : [ 'Link','Unlink','Anchor' ] },
+	{ name: 'insert',		items : [ 'Image','Flash','Table','HorizontalRule','Smiley','SpecialChar','PageBreak','Iframe' ] },
 	'/',
-	['Styles','Format','Font','FontSize'],
-	['TextColor','BGColor'],
-	['Maximize', 'ShowBlocks','-','About']
+	{ name: 'styles',		items : [ 'Styles','Format','Font','FontSize' ] },
+	{ name: 'colors',		items : [ 'TextColor','BGColor' ] },
+	{ name: 'tools',		items : [ 'Maximize', 'ShowBlocks','-','About' ] }
 ];
 
@@ -500,2 +531,15 @@
  * config.toolbarStartupExpanded = false;
  */
+
+/**
+ * When enabled, makes the arrow keys navigation cycle within the current
+ * toolbar group. Otherwise the arrows will move trought all items available in
+ * the toolbar. The TAB key will still be used to quickly jump among the
+ * toolbar groups.
+ * @name CKEDITOR.config.toolbarGroupCycling
+ * @since 3.6
+ * @type Boolean
+ * @default true
+ * @example
+ * config.toolbarGroupCycling = false;
+ */
Index: CKEditor/trunk/_source/plugins/undo/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/undo/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/undo/plugin.js	(revision 6904)
@@ -91,5 +91,5 @@
 			editor.on( 'mode', function()
 				{
-					undoManager.enabled = editor.mode == 'wysiwyg';
+					undoManager.enabled = editor.readOnly ? false : editor.mode == 'wysiwyg';
 					undoManager.onChange();
 				});
Index: CKEditor/trunk/_source/plugins/wysiwygarea/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/wysiwygarea/plugin.js	(revision 6896)
+++ CKEditor/trunk/_source/plugins/wysiwygarea/plugin.js	(revision 6904)
@@ -382,10 +382,11 @@
 		}
 
-		// When enterMode set to block, we'll establing new paragraph only if we're
-		// selecting inline contents right under body. (#3657)
-		if ( enterMode != CKEDITOR.ENTER_BR
-		     && range.collapsed
-			 && blockLimit.getName() == 'body'
-			 && !path.block )
+		// When we're in block enter mode, a new paragraph will be established
+		// to encapsulate inline contents right under body. (#3657)
+		if ( editor.config.autoParagraph !== false
+				&& enterMode != CKEDITOR.ENTER_BR
+				&& range.collapsed
+				&& blockLimit.getName() == 'body'
+				&& !path.block )
 		{
 			editor.fire( 'updateSnapshot' );
@@ -462,5 +463,5 @@
 		init : function( editor )
 		{
-			var fixForBody = ( editor.config.enterMode != CKEDITOR.ENTER_BR )
+			var fixForBody = ( editor.config.enterMode != CKEDITOR.ENTER_BR && editor.config.autoParagraph !== false )
 				? editor.config.enterMode == CKEDITOR.ENTER_DIV ? 'div' : 'p' : false;
 
@@ -589,4 +590,6 @@
 						body.spellcheck = !editor.config.disableNativeSpellChecker;
 
+						var editable = !editor.readOnly;
+
 						if ( CKEDITOR.env.ie )
 						{
@@ -597,5 +600,5 @@
 							// taking the editing focus at startup. (#141 / #523)
 							body.disabled = true;
-							body.contentEditable = true;
+							body.contentEditable = editable;
 							body.removeAttribute( 'disabled' );
 						}
@@ -609,18 +612,18 @@
 								if ( CKEDITOR.env.gecko && CKEDITOR.env.version >= 10900
 										|| CKEDITOR.env.opera )
-									domDocument.$.body.contentEditable = true;
+									domDocument.$.body.contentEditable = editable;
 								else if ( CKEDITOR.env.webkit )
-									domDocument.$.body.parentNode.contentEditable = true;
+									domDocument.$.body.parentNode.contentEditable = editable;
 								else
-									domDocument.$.designMode = 'on';
+									domDocument.$.designMode = editable? 'off' : 'on';
 							}, 0 );
 						}
 
-						CKEDITOR.env.gecko && CKEDITOR.tools.setTimeout( activateEditing, 0, null, editor );
+						editable && CKEDITOR.env.gecko && CKEDITOR.tools.setTimeout( activateEditing, 0, null, editor );
 
 						domWindow	= editor.window	= new CKEDITOR.dom.window( domWindow );
 						domDocument	= editor.document	= new CKEDITOR.dom.document( domDocument );
 
-						domDocument.on( 'dblclick', function( evt )
+						editable && domDocument.on( 'dblclick', function( evt )
 						{
 							var element = evt.data.getTarget(),
@@ -703,6 +706,6 @@
 						// IE standard compliant in editing frame doesn't focus the editor when
 						// clicking outside actual content, manually apply the focus. (#1659)
-						if ( CKEDITOR.env.ie
-							&& domDocument.$.compatMode == 'CSS1Compat'
+						if ( editable &&
+								CKEDITOR.env.ie && domDocument.$.compatMode == 'CSS1Compat'
 								|| CKEDITOR.env.gecko
 								|| CKEDITOR.env.opera )
@@ -735,5 +738,5 @@
 								var doc = editor.document;
 
-								if ( CKEDITOR.env.gecko && CKEDITOR.env.version >= 10900 )
+								if ( editable && CKEDITOR.env.gecko && CKEDITOR.env.version >= 10900 )
 									blinkCursor();
 								else if ( CKEDITOR.env.opera )
@@ -753,6 +756,7 @@
 
 						var keystrokeHandler = editor.keystrokeHandler;
-						if ( keystrokeHandler )
-							keystrokeHandler.attach( domDocument );
+						// Prevent backspace from navigating off the page.
+						keystrokeHandler.blockedKeystrokes[ 8 ] = !editable;
+						keystrokeHandler.attach( domDocument );
 
 						if ( CKEDITOR.env.ie )
@@ -761,5 +765,5 @@
 							// Override keystrokes which should have deletion behavior
 							//  on control types in IE . (#4047)
-							domDocument.on( 'keydown', function( evt )
+							editable && domDocument.on( 'keydown', function( evt )
 							{
 								var keyCode = evt.data.getKeystroke();
@@ -950,4 +954,8 @@
 											editor.docType = docType = match;
 											return '';
+										}).replace( /<\?xml\s[^\?]*\?>/i, function( match )
+										{
+											editor.xmlDeclaration = match;
+											return '';
 										});
 								}
@@ -1022,4 +1030,5 @@
 									fullPage = config.fullPage,
 									docType = fullPage && editor.docType,
+									xmlDeclaration = fullPage && editor.xmlDeclaration,
 									doc = iframe.getFrameDocument();
 
@@ -1039,4 +1048,6 @@
 									data = data.replace( emptyParagraphRegexp, function( match, lookback ) { return lookback; } );
 
+								if ( xmlDeclaration )
+									data = xmlDeclaration + '\n' + data;
 								if ( docType )
 									data = docType + '\n' + data;
@@ -1128,4 +1139,14 @@
 				});
 
+			editor.on( 'readOnly', function()
+				{
+					if ( editor.mode == 'wysiwyg' )
+					{
+						// Symply reload the wysiwyg area. It'll take care of read-only.
+						var wysiwyg = editor.getMode();
+						wysiwyg.loadData( wysiwyg.getData() );
+					}
+				});
+
 			// IE>=8 stricts mode doesn't have 'contentEditable' in effect
 			// on element unless it has layout. (#5562)
@@ -1141,9 +1162,23 @@
 			// Set the HTML style to 100% to have the text cursor in affect (#6341)
 			else if ( CKEDITOR.env.gecko )
+			{
 				editor.addCss( 'html { height: 100% !important; }' );
+				editor.addCss( 'img:-moz-broken { -moz-force-broken-image-icon : 1;	width : 24px; height : 24px; }' );
+			}
+
+			/* #3658: [IE6] Editor document has horizontal scrollbar on long lines
+			To prevent this misbehavior, we show the scrollbar always */
+			/* #6341: The text cursor must be set on the editor area. */
+			/* #6632: Avoid having "text" shape of cursor in IE7 scrollbars.*/
+			editor.addCss( 'html {	_overflow-y: scroll; cursor: text;	*cursor:auto;}' );
+			// Use correct cursor for these elements
+			editor.addCss( 'img, input, textarea { cursor: default;}' );
 
 			// Switch on design mode for a short while and close it after then.
 			function blinkCursor( retry )
 			{
+				if ( editor.readOnly )
+					return;
+
 				CKEDITOR.tools.tryThese(
 					function()
@@ -1298,4 +1333,16 @@
 
 /**
+ * Whether automatically create wrapping blocks around inline contents inside document body,
+ * this helps to ensure the integrality of the block enter mode.
+ * <strong>Note:</strong> Changing the default value might introduce unpredictable usability issues.
+ * @name CKEDITOR.config.autoParagraph
+ * @since 3.6
+ * @type Boolean
+ * @default true
+ * @example
+ * config.autoParagraph = false;
+ */
+
+/**
  * Fired when some elements are added to the document
  * @name CKEDITOR.editor#ariaWidget
Index: CKEditor/trunk/_source/skins/kama/skin.js
===================================================================
--- CKEditor/trunk/_source/skins/kama/skin.js	(revision 6896)
+++ CKEditor/trunk/_source/skins/kama/skin.js	(revision 6904)
@@ -11,4 +11,5 @@
 		editor		: { css : [ 'editor.css' ] },
 		dialog		: { css : [ 'dialog.css' ] },
+		richcombo	: { canGroup: false },
 		templates	: { css : [ 'templates.css' ] },
 		margins		: [ 0, 0, 0, 0 ],
Index: CKEditor/trunk/_source/skins/office2003/skin.js
===================================================================
--- CKEditor/trunk/_source/skins/office2003/skin.js	(revision 6896)
+++ CKEditor/trunk/_source/skins/office2003/skin.js	(revision 6904)
@@ -9,4 +9,5 @@
 		editor		: { css : [ 'editor.css' ] },
 		dialog		: { css : [ 'dialog.css' ] },
+		separator		: { canGroup: false },
 		templates	: { css : [ 'templates.css' ] },
 		margins		: [ 0, 14, 18, 14 ]
Index: CKEditor/trunk/_source/skins/v2/skin.js
===================================================================
--- CKEditor/trunk/_source/skins/v2/skin.js	(revision 6896)
+++ CKEditor/trunk/_source/skins/v2/skin.js	(revision 6904)
@@ -9,4 +9,5 @@
 		editor		: { css : [ 'editor.css' ] },
 		dialog		: { css : [ 'dialog.css' ] },
+		separator		: { canGroup: false },
 		templates	: { css : [ 'templates.css' ] },
 		margins		: [ 0, 14, 18, 14 ]
Index: CKEditor/trunk/ckeditor.pack
===================================================================
--- CKEditor/trunk/ckeditor.pack	(revision 6896)
+++ CKEditor/trunk/ckeditor.pack	(revision 6904)
@@ -49,5 +49,5 @@
 		'CKEDITOR.SHRINK_ELEMENT' : 1,
 		'CKEDITOR.SHRINK_TEXT' : 2,
-		'CKEDITOR.UI_BUTTON' : 1,
+		'CKEDITOR.UI_BUTTON' : '\'button\'',
 		'CKEDITOR.DIALOG_RESIZE_NONE' : 0,
 		'CKEDITOR.DIALOG_RESIZE_WIDTH' : 1,
@@ -59,11 +59,11 @@
 		'CKEDITOR.STYLE_INLINE' : 2,
 		'CKEDITOR.STYLE_OBJECT' : 3,
-		'CKEDITOR.UI_PANELBUTTON' : 4,
+		'CKEDITOR.UI_PANELBUTTON' : '\'panelbutton\'',
 		'CKEDITOR.SELECTION_NONE' : 1,
 		'CKEDITOR.SELECTION_TEXT' : 2,
 		'CKEDITOR.SELECTION_ELEMENT' : 3,
-		'CKEDITOR.UI_RICHCOMBO' : 3,
-		'CKEDITOR.UI_MENUBUTTON' : 5,
-		'CKEDITOR.UI_PANEL' : 2
+		'CKEDITOR.UI_RICHCOMBO' : '\'richcombo\'',
+		'CKEDITOR.UI_MENUBUTTON' : '\'menubutton\'',
+		'CKEDITOR.UI_PANEL' : '\'panel\''
 	},
 
